// This is a TextMate grammar distributed by `starry-night`.
// This grammar is developed at
// <https://github.com/JonBons/Sublime-SQF-Language>
// and licensed `apache-2.0`.
// See <https://github.com/wooorm/starry-night> for more info.
/**
 * @import {Grammar} from '@wooorm/starry-night'
 */

/** @type {Grammar} */
const grammar = {
  extensions: ['.sqf', '.hqf'],
  names: ['sqf'],
  patterns: [
    {match: '\\#ifdef|\\#ifndef|\\#else|\\#endif', name: 'keyword.other.sqf'},
    {match: '\\#include', name: 'keyword.control.import.sqf'},
    {match: 'private|\\#define|\\#undef', name: 'keyword.declaration.sqf'},
    {
      match:
        '\\b(?i:_exception|_foreachindex|_this|_thisfsm|_thislist|_thisscript|_x)\\b',
      name: 'variable.language.sqf'
    },
    {
      match:
        '\\b(?i:blufor|civilian|configNull|controlNull|displayNull|east|endl|false|grpNull|independent|lineBreak|locationNull|nil|objNull|opfor|pi|resistance|scriptNull|sideAmbientLife|sideEmpty|sideLogic|sideUnknown|taskNull|teamMemberNull|true|west|__EVAL|__EXEC|__FILE__|__LINE__)\\b|\\:|\\!|&&|\\|\\||>>',
      name: 'constant.language.sqf'
    },
    {
      match:
        '\\b(?i:if|then|else|exitwith|while|do|switch|case|default|for|from|to|step|foreach|foreachmember|foreachmemberagent|foreachmemberteam|try|throw|catch|scopename|break|breakwith|breakto|breakout|continue|continuewith|with|call|spawn|preprocessfile|preprocessfilelinenumbers|execvm|execfsm|not|and|or)\\b|\\:|\\!|&&|\\|\\||>>',
      name: 'keyword.control.sqf'
    },
    {
      match:
        '\\b(?i:alldiarysubjects|binocularitems|binocularmagazine|combatbehaviour|compilescript|createhashmapfromarray|ctrlfontheight|ctrlstyle|ctrltextcolor|ctrltooltip|ctrlurl|diag_localized|fileexists|flatten|focusedctrl|forcecadetdifficulty|forceunicode|getallpylonsinfo|getobjectscale|getplayerid|gettextraw|keys|markerchannel|markerpolyline|markershadow|menusetshortcut|menusettext|menuseturl|opengps|removeallbinocularitems|removeallsecondaryweaponitems|removebinocularitem|ropesegments|taskname|trim|tvselection|unitcombatmode|abs|acos|action|actionids|actionkeys|actionkeysex|actionkeysimages|actionkeysnames|actionkeysnamesarray|actionname|activateaddons|activatekey|activetitleeffectparams|add3denconnection|add3deneventhandler|addcamshake|addcuratorselected|addforcegeneratorrtd|additempool|addmagazinepool|addmissioneventhandler|addmusiceventhandler|addonfiles|addswitchableunit|addtoremainscollector|adduseractioneventhandler|addweaponpool|admin|agent|agltoasl|aimpos|airdensityrtd|airplanethrottle|airportside|aisfinishheal|alive|allcontrols|alllods|allmissionobjects|allowedservice|allsimpleobjects|allturrets|allvariables|angularvelocity|angularvelocitymodelspace|animationnames|animationstate|asin|asltoagl|asltoatl|assert|assignedcargo|assignedcommander|assigneddriver|assignedgroup|assignedgunner|assigneditems|assignedtarget|assignedteam|assignedvehicle|assignedvehiclerole|assignedvehicles|atan|atg|atltoasl|attachedobject|attachedobjects|attachedto|attackenabled|backpack|backpackcargo|backpackcontainer|backpackitems|backpackmagazines|backpacks|behaviour|binocular|boundingbox|boundingboxreal|boundingcenter|brakesdisabled|buldozer_enableroaddiag|buldozer_loadnewroads|buttonaction|buttonsetaction|calculatepath|calculateplayervisibilitybyfriendly|camcommitted|camdestroy|cameraeffectenablehud|camerainterest|campreloaded|camtarget|camusenvg|cancelsimpletaskdestination|candeployweapon|canfire|canmove|canstand|cantriggerdynamicsimulation|canunloadincombat|captive|captivenum|cbchecked|ceil|channelenabled|checkaifeature|classname|clear3deninventory|clearallitemsfrombackpack|clearbackpackcargo|clearbackpackcargoglobal|cleargroupicons|clearitemcargo|clearitemcargoglobal|clearmagazinecargo|clearmagazinecargoglobal|clearoverlay|clearweaponcargo|clearweaponcargoglobal|closedialog|closeoverlay|collapseobjecttree|collect3denhistory|collectivertd|collisiondisabledwith|combatmode|commander|commandgetout|commandstop|comment|commitoverlay|compatibleitems|compatiblemagazines|compile|compilefinal|completedfsm|composetext|confighierarchy|configname|configof|configproperties|configsourceaddonlist|configsourcemod|configsourcemodlist|connecttoserver|conversationdisabled|copytoclipboard|cos|count|create3dencomposition|create3denentity|createagent|createcenter|createdialog|creatediarylink|creategeardialog|creategroup|createguardedpoint|createhashmapobject|createlocation|createmarker|createmarkerlocal|createmine|createsimpleobject|createsoundsource|createteam|createtrigger|createvehicle|createvehiclecrew|createvehiclelocal|crew|ctaddheader|ctaddrow|ctclear|ctcursel|ctheadercount|ctrlactivate|ctrlangle|ctrlautoscrolldelay|ctrlautoscrollrewind|ctrlautoscrollspeed|ctrlbackgroundcolor|ctrlchecked|ctrlclassname|ctrlcommitted|ctrldelete|ctrlenable|ctrlenabled|ctrlfade|ctrlforegroundcolor|ctrlhtmlloaded|ctrlidc|ctrlidd|ctrlmapanimclear|ctrlmapanimcommit|ctrlmapanimdone|ctrlmapdir|ctrlmapmouseover|ctrlmapposition|ctrlmapscale|ctrlmodel|ctrlmodeldirandup|ctrlmodelscale|ctrlmouseposition|ctrlparent|ctrlparentcontrolsgroup|ctrlposition|ctrlscale|ctrlscrollvalues|ctrlsetfocus|ctrlsettext|ctrlshadow|ctrlshow|ctrlshown|ctrltext|ctrltextheight|ctrltextsecondary|ctrltextselection|ctrltextwidth|ctrltype|ctrlurloverlaymode|ctrlvisible|ctrowcount|curatoraddons|curatorcameraarea|curatorcameraareaceiling|curatoreditableobjects|curatoreditingarea|curatoreditingareatype|curatorpoints|curatorregisteredobjects|curatorselectionpreset|curatorwaypointcost|currentcommand|currentmagazine|currentmagazinedetail|currentmuzzle|currentpilot|currenttask|currenttasks|currentthrowable|currentvisionmode|currentwaypoint|currentweapon|currentweaponmode|currentzeroing|cutobj|cutrsc|cuttext|damage|datetonumber|deactivatekey|debriefingtext|debuglog|decaygraphvalues|deg|delete3denentities|deletecenter|deletecollection|deletegroup|deleteidentity|deletelocation|deletemarker|deletemarkerlocal|deletesite|deletestatus|deleteteam|deletevehicle|deletevehiclecrew|deletewaypoint|detach|detectedmines|diag_captureframe|diag_captureframetofile|diag_captureslowframe|diag_codeperformance|diag_drawmode|diag_dumpscriptassembly|diag_dynamicsimulationend|diag_enabled|diag_exportconfig|diag_exportterrainsvg|diag_getterrainsegmentoffset|diag_lightnewload|diag_list|diag_log|diag_logslowframe|diag_mergeconfigfile|diag_recordturretlimits|diag_remainscollector|diag_setlightnew|diag_sqfcdebugdump|diag_testscriptsimplevm|diag_toggle|didjipowner|difficultyenabled|difficultyoption|direction|disablemapindicators|disableremotesensors|disableuserinput|displaychild|displayctrl|displayparent|displayuniquename|displayupdate|dissolveteam|do3denaction|dogetout|dostop|drawicon3d|drawlaser|drawline3d|driver|drop|dynamicsimulationdistance|dynamicsimulationdistancecoef|dynamicsimulationenabled|echo|edit3denmissionattributes|effectivecommander|enableaudiofeature|enablecamshake|enablecaustics|enabledebriefingstats|enablediaglegend|enabledynamicsimulationsystem|enableengineartillery|enableenvironment|enableradio|enablesatnormalondetail|enablesaving|enablesentences|enablestressdamage|enableteamswitch|enabletraffic|enableweapondisassembly|endmission|enginesisonrtd|enginespowerrtd|enginesrpmrtd|enginestorquertd|entities|equipmentdisabled|estimatedtimeleft|everybackpack|everycontainer|exp|expecteddestination|exportjipmessages|eyedirection|eyepos|face|faction|failmission|fillweaponsfrompool|finddisplay|finite|firstbackpack|flag|flaganimationphase|flagowner|flagside|flagtexture|fleeing|floor|forceatpositionrtd|forcegeneratorrtd|forcehitpointsdamagesync|forcemap|forcerespawn|format|formation|formationdirection|formationleader|formationmembers|formationposition|formationtask|formattext|formleader|freeextension|fromeditor|fuel|fullcrew|gearidcammocount|gearslotammocount|gearslotdata|gesturestate|get3denactionstate|get3denconnections|get3denentity|get3denentityid|get3dengrid|get3denlayer|get3denlayerentities|get3denparent|get3denselected|getaimingcoef|getallenv3dsoundcontrollers|getallenvsoundcontrollers|getallhitpointsdamage|getallownedmines|getallsoundcontrollers|getallunittraits|getammocargo|getanimaimprecision|getanimspeedcoef|getarray|getartilleryammo|getassetdlcinfo|getassignedcuratorlogic|getassignedcuratorunit|getattacktarget|getbackpackcargo|getbleedingremaining|getbonenames|getburningvalue|getcameraviewdirection|getcenterofmass|getconnecteduav|getconnecteduavunit|getcontainermaxload|getcorpse|getcorpseweaponholders|getcruisecontrol|getcustomaimcoef|getcustomsoundcontroller|getcustomsoundcontrollercount|getdammage|getdebriefingtext|getdescription|getdir|getdirvisual|getdiverstate|getdlcassetsusagebyname|getdlcs|getdlcusagetime|geteditorcamera|geteditormode|getenginetargetrpmrtd|getentityinfo|geteventhandlerinfo|getfatigue|getfieldmanualstartpage|getforcedflagtexture|getforcedspeed|getfuelcargo|getfuelconsumptioncoef|getgraphvalues|getgroupiconparams|getgroupicons|getitemcargo|getleaning|getlightingat|getmagazinecargo|getmarkercolor|getmarkerpos|getmarkersize|getmarkertype|getmass|getmissionconfig|getmissionconfigvalue|getmissionlayerentities|getmissionpath|getmodelinfo|getnumber|getobjectdlc|getobjectfov|getobjectid|getobjectmaterials|getobjecttextures|getobjecttype|getoxygenremaining|getpersonuseddlcs|getpilotcameradirection|getpilotcameraopticsmode|getpilotcameraposition|getpilotcamerarotation|getpilotcameratarget|getplatenumber|getplayerchannel|getplayerscores|getplayeruid|getplayervonvolume|getpos|getposasl|getposaslvisual|getposaslw|getposatl|getposatlvisual|getposvisual|getposworld|getposworldvisual|getpylonmagazines|getrepaircargo|getrespawnvehicleinfo|getroadinfo|getrotorbrakertd|getsensortargets|getsensorthreats|getshotinfo|getshotparents|getslingload|getstamina|getstatvalue|getsuppression|getterrainheight|getterrainheightasl|gettext|gettextureinfo|gettowparent|gettrimoffsetrtd|getturretopticsmode|getunitfreefallinfo|getunitloadout|getunitmovesinfo|getunloadincombat|getuserinfo|getusermfdtext|getusermfdvalue|getvehiclecargo|getvehicletipars|getwaterfillpercentage|getwaterleakiness|getweaponcargo|getweaponsway|getwingsorientationrtd|getwingspositionrtd|getwppos|goggles|goto|group|groupfromnetid|groupid|groupowner|groups|groupselectedunits|gunner|handgunitems|handgunmagazine|handgunweapon|handshit|hashvalue|haspilotcamera|hcallgroups|hcleader|hcremoveallgroups|hcselected|hcshowbar|headgear|hidebody|hideobject|hideobjectglobal|hint|hintc|hintcadet|hintsilent|hmd|hostmission|ignore3denhistory|image|import|importallgroups|importance|incapacitatedstate|inflamed|infopanel|infopanels|ingameuiseteventhandler|inheritsfrom|inputaction|inputcontroller|inputmouse|insidebuilding|isabletobreathe|isagent|isaimprecisionenabled|isaisteeringcomponentenabled|isallowedcrewinimmobile|isarray|isautohoveron|isautonomous|isautostartupenabledrtd|isautotrimonrtd|isawake|isbleeding|isburning|isclass|iscollisionlighton|iscopilotenabled|isdamageallowed|isdlcavailable|isengineon|isfinal|isforcedwalk|isformationleader|isgroupdeletedwhenempty|ishidden|isinremainscollector|iskeyactive|islaseron|islighton|islocalized|ismanualfire|ismarkedforcollection|isnil|isnull|isnumber|isobjecthidden|isobjectrtd|isonroad|isplayer|isrealtime|isremotecontrolling|isshowing3dicons|issimpleobject|issprintallowed|isstaminaenabled|istext|isthrowable|istouchingground|isturnedout|isuavconnected|isvehiclecargo|isvehicleradaron|iswalking|isweapondeployed|isweaponrested|itemcargo|items|itemswithmagazines|keyimage|keyname|landresult|lasertarget|lbadd|lbclear|lbcolor|lbcolorright|lbcursel|lbdata|lbdelete|lbpicture|lbpictureright|lbselection|lbsetcolor|lbsetcolorright|lbsetcursel|lbsetdata|lbsetpicture|lbsetpicturecolor|lbsetpicturecolordisabled|lbsetpicturecolorselected|lbsetpictureright|lbsetselectcolor|lbsetselectcolorright|lbsettext|lbsettooltip|lbsetvalue|lbsize|lbsort|lbsortbyvalue|lbtext|lbtextright|lbtooltip|lbvalue|leader|leaderboarddeinit|leaderboardgetrows|leaderboardinit|leaderboardrequestrowsfriends|leaderboardrequestrowsglobal|leaderboardrequestrowsglobalarounduser|leaderboardsrequestuploadscore|leaderboardsrequestuploadscorekeepbest|leaderboardstate|lifestate|lightdetachobject|lightison|linearconversion|lineintersects|lineintersectsobjs|lineintersectssurfaces|lineintersectswith|list|listremotetargets|listvehiclesensors|ln|lnbaddarray|lnbaddcolumn|lnbaddrow|lnbclear|lnbcolor|lnbcolorright|lnbcurselrow|lnbdata|lnbdeletecolumn|lnbdeleterow|lnbgetcolumnsposition|lnbpicture|lnbpictureright|lnbsetcolor|lnbsetcolorright|lnbsetcolumnspos|lnbsetcurselrow|lnbsetdata|lnbsetpicture|lnbsetpicturecolor|lnbsetpicturecolorright|lnbsetpicturecolorselected|lnbsetpicturecolorselectedright|lnbsetpictureright|lnbsettext|lnbsettextright|lnbsettooltip|lnbsetvalue|lnbsize|lnbsort|lnbsortbyvalue|lnbtext|lnbtextright|lnbvalue|load|load3denscenario|loadabs|loadbackpack|loadconfig|loadcuratorselectionpreset|loadfile|loaduniform|loadvest|local|localize|locationposition|locked|lockeddriver|lockedinventory|lockidentity|log|lognetwork|lognetworkterminate|magazinecargo|magazines|magazinesallturrets|magazinesammo|magazinesammocargo|magazinesammofull|magazinesdetail|magazinesdetailbackpack|magazinesdetailuniform|magazinesdetailvest|mapanimadd|mapcenteroncamera|mapgridposition|markeralpha|markerbrush|markercolor|markerdir|markerdrawpriority|markerpos|markershape|markersize|markertext|markertype|matrixtranspose|maxload|members|menuaction|menuadd|menuchecked|menuclear|menucollapse|menudata|menudelete|menuenable|menuenabled|menuexpand|menuhover|menupicture|menusetaction|menusetcheck|menusetdata|menusetpicture|menusetvalue|menushortcut|menushortcuttext|menusize|menusort|menutext|menuurl|menuvalue|mineactive|missiletarget|missiletargetpos|modparams|moonphase|morale|move3dencamera|moveout|movetime|movetocompleted|movetofailed|name|namedproperties|namesound|nearestbuilding|nearestlocation|nearestlocations|nearestlocationwithdubbing|nearestmines|nearestobject|nearestobjects|nearestterrainobjects|needreload|needservice|netid|nextmenuitemindex|numberofenginesrtd|numbertodate|objectcurators|objectfromnetid|objectparent|onbriefinggroup|onbriefingnotes|onbriefingplan|onbriefingteamswitch|oncommandmodechanged|oneachframe|ongroupiconclick|ongroupiconoverenter|ongroupiconoverleave|onhcgroupselectionchanged|onmapsingleclick|onplayerconnected|onplayerdisconnected|onpreloadfinished|onpreloadstarted|onteamswitch|opendlcpage|openmap|opensteamapp|openyoutubevideo|owner|param|params|parsenumber|parsesimplearray|parsetext|pickweaponpool|pitch|playableslotsnumber|playersnumber|playmission|playmusic|playscriptedmission|playsound|playsound3d|playsoundui|pose|position|positioncameratoworld|ppeffectcommitted|ppeffectcreate|ppeffectdestroy|ppeffectenabled|precision|preloadcamera|preloadsound|preloadtitleobj|preloadtitlersc|primaryweapon|primaryweaponitems|primaryweaponmagazine|priority|processdiarylink|progressloadingscreen|progressposition|publicvariable|publicvariableserver|putweaponpool|queryitemspool|querymagazinepool|queryweaponpool|rad|radiochannelcreate|radiochannelinfo|random|rank|rankid|rating|rectangular|registeredtasks|reload|reloadenabled|remotecontrolled|remoteexec|remoteexeccall|remove3denconnection|remove3deneventhandler|remove3denlayer|removeall3deneventhandlers|removeallactions|removeallassigneditems|removeallcontainers|removeallcuratoraddons|removeallcuratorcameraareas|removeallcuratoreditingareas|removeallhandgunitems|removeallitems|removeallitemswithmagazines|removeallmissioneventhandlers|removeallmusiceventhandlers|removeallownedmines|removeallprimaryweaponitems|removealluseractioneventhandlers|removeallweapons|removebackpack|removebackpackglobal|removefromremainscollector|removegoggles|removeheadgear|removemissioneventhandler|removemusiceventhandler|removeswitchableunit|removeuniform|removeuseractioneventhandler|removevest|requiredversion|resetsubgroupdirection|resources|restarteditorcamera|reverse|roadat|roadsconnectedto|roledescription|ropeattachedobjects|ropeattachedto|ropeattachenabled|ropecreate|ropecut|ropedestroy|ropeendposition|ropelength|ropes|ropesattachedto|ropeunwind|ropeunwound|rotorsforcesrtd|rotorsrpmrtd|round|save3deninventory|saveoverlay|savevar|score|scoreside|screenshot|screentoworld|scriptdone|scriptname|scudstate|secondaryweapon|secondaryweaponitems|secondaryweaponmagazine|selectbestplaces|selectededitorobjects|selectionnames|selectionposition|selectmax|selectmin|selectplayer|selectrandom|selectrandomweighted|sendaumessage|sendudpmessage|servercommand|servercommandavailable|servercommandexecutable|set3denattributes|set3dengrid|set3deniconsvisible|set3denlinesvisible|set3denmissionattributes|set3denmodelsvisible|set3denselected|setacctime|setaperture|setaperturenew|setarmorypoints|setcamshakedefparams|setcamshakeparams|setcompassdeclination|setcompassoscillation|setcuratorselected|setcurrentchannel|setcustommissiondata|setcustomsoundcontroller|setdate|setdefaultcamera|setdetailmapblendpars|setgroupiconsselectable|setgroupiconsvisible|sethorizonparallaxcoef|sethudmovementlevels|sethumidity|setinfopanel|setlocalwindparams|setmissionoptions|setmouseposition|setmusiceventhandler|setobjectviewdistance|setpipviewdistance|setplayable|setplayerrespawntime|setrain|setshadowdistance|setsimulweatherlayers|setstaminascheme|setstatvalue|setsystemofunits|setterraingrid|setterrainheight|settimemultiplier|settiparameter|settrafficdensity|settrafficdistance|settrafficgap|settrafficspeed|setviewdistance|setwind|setwinddir|showchat|showcinemaborder|showcommandingmenu|showcompass|showcuratorcompass|showgps|showhud|showmap|showpad|showradio|showscoretable|showsubtitles|showuavfeed|showwarrant|showwatch|showwaypoints|side|simpletasks|simulationenabled|simulclouddensity|simulcloudocclusion|simulinclouds|sin|size|sizeof|skill|skiptime|sleep|sliderposition|sliderrange|slidersetposition|slidersetrange|slidersetspeed|sliderspeed|soldiermagazines|someammo|soundparams|speaker|speed|speedmode|sqrt|squadparams|stance|startloadingscreen|stopenginertd|stopped|stopsound|str|supportinfo|surfaceiswater|surfacenormal|surfacetexture|surfacetype|switchcamera|synchronizedobjects|synchronizedtriggers|synchronizedwaypoints|systemchat|tan|taskalwaysvisible|taskchildren|taskcompleted|taskcustomdata|taskdescription|taskdestination|taskhint|taskmarkeroffset|taskparent|taskresult|taskstate|tasktype|teammember|teamname|teamtype|terminate|terrainintersect|terrainintersectasl|terrainintersectatasl|text|textlog|textlogformat|tg|throwables|titlecut|titlefadeout|titleobj|titlersc|titletext|toarray|tofixed|tolower|toloweransi|tostring|toupper|toupperansi|triggeractivated|triggeractivation|triggerammo|triggerarea|triggerattachedvehicle|triggerinterval|triggerstatements|triggertext|triggertimeout|triggertimeoutcurrent|triggertype|tvadd|tvclear|tvcollapse|tvcollapseall|tvcount|tvcursel|tvdata|tvdelete|tvexpand|tvexpandall|tvpicture|tvpictureright|tvsetcursel|tvsetdata|tvsetpicture|tvsetpicturecolor|tvsetpictureright|tvsetpicturerightcolor|tvsettext|tvsettooltip|tvsetvalue|tvsort|tvsortbyvalue|tvtext|tvtooltip|tvvalue|type|typename|typeof|uavcontrol|uisleep|unassigncurator|unassignteam|unassignvehicle|underwater|uniform|uniformcontainer|uniformitems|uniformmagazines|uniqueunititems|unitaddons|unitaimposition|unitaimpositionvisual|unitbackpack|unitisuav|unitpos|unitready|unitrecoilcoefficient|units|unlockachievement|updateobjecttree|useaiopermapobstructiontest|useaisteeringcomponent|values|vectordir|vectordirvisual|vectorlinearconversion|vectormagnitude|vectormagnitudesqr|vectornormalized|vectorside|vectorsidevisual|vectorup|vectorupvisual|vehicle|vehiclecargoenabled|vehiclemoveinfo|vehiclereceiveremotetargets|vehiclereportownposition|vehiclereportremotetargets|vehiclevarname|velocity|velocitymodelspace|verifysignature|vest|vestcontainer|vestitems|vestmagazines|visibleposition|visiblepositionasl|waituntil|waterdamaged|waypointattachedobject|waypointattachedvehicle|waypointbehaviour|waypointcombatmode|waypointcompletionradius|waypointdescription|waypointforcebehaviour|waypointformation|waypointhouseposition|waypointloiteraltitude|waypointloiterradius|waypointloitertype|waypointname|waypointposition|waypoints|waypointscript|waypointsenableduav|waypointshow|waypointspeed|waypointstatements|waypointtimeout|waypointtimeoutcurrent|waypointtype|waypointvisible|weaponcargo|weapondisassemblyenabled|weaponinertia|weaponlowered|weapons|weaponsitems|weaponsitemscargo|weaponstate|weightrtd|wfsidetext|wingsforcesrtd|worldtoscreen)\\b',
      name: 'support.function.sqf'
    },
    {
      match:
        '\\b(?i:addbinocularitem|ctrlsetmouseposition|ctrlseturl|fadeenvironment|get|getordefault|insert|isnotequalto|merge|setmarkerpolyline|setmarkerpolylinelocal|setobjectscale|setunitcombatmode|tvisselected|tvsetselected|tvsortall|tvsortbyvalueall|setcombatbehaviour|setdiarysubjectpicture|setmarkershadow|setmarkershadowlocal|setweaponzeroing|action|actionnow|actionparams|add3denlayer|addaction|addbackpack|addbackpackcargo|addbackpackcargoglobal|addbackpackglobal|addcuratoraddons|addcuratorcameraarea|addcuratoreditableobjects|addcuratoreditingarea|addcuratorpoints|addeditorobject|addeventhandler|addforce|addgoggles|addgroupicon|addhandgunitem|addheadgear|additem|additemcargo|additemcargoglobal|additemtobackpack|additemtouniform|additemtovest|addlivestats|addmagazine|addmagazineammocargo|addmagazinecargo|addmagazinecargoglobal|addmagazineglobal|addmagazines|addmagazineturret|addmenu|addmenuitem|addmpeventhandler|addownedmine|addplayerscores|addprimaryweaponitem|addpublicvariableeventhandler|addrating|addresources|addscore|addscoreside|addsecondaryweaponitem|addteammember|addtorque|adduniform|addvehicle|addvest|addwaypoint|addweapon|addweaponcargo|addweaponcargoglobal|addweaponglobal|addweaponitem|addweaponturret|addweaponwithattachmentscargo|addweaponwithattachmentscargoglobal|aimedattarget|alldiaryrecords|allobjects|allow3dmode|allowcrewinimmobile|allowcuratorlogicignoreareas|allowdamage|allowdammage|allowfileoperations|allowfleeing|allowgetin|allowservice|allowsprint|ammo|ammoonpylon|animate|animatebay|animatedoor|animatepylon|animatesource|animationphase|animationsourcephase|append|apply|arrayintersect|assignascargo|assignascargoindex|assignascommander|assignasdriver|assignasgunner|assignasturret|assigncurator|assignitem|assignteam|assigntoairport|atan2|attachobject|attachto|awake|backpackspacefor|bezierinterpolation|boundingbox|boundingboxreal|buildingexit|buildingpos|buttonsetaction|callextension|camcommand|camcommit|camcommitprepared|camconstuctionsetparams|camcreate|cameraeffect|campreload|campreparebank|campreparedir|campreparedive|campreparefocus|campreparefov|campreparefovrange|campreparepos|campreparerelpos|campreparetarget|camsetbank|camsetdir|camsetdive|camsetfocus|camsetfov|camsetfovrange|camsetpos|camsetrelpos|camsettarget|canadd|canadditemtobackpack|canadditemtouniform|canadditemtovest|canslingload|canvehiclecargo|cbsetchecked|checkaifeature|checkvisibility|clear3denattribute|closedisplay|collect3denhistory|commandartilleryfire|commandchat|commandfire|commandfollow|commandfsm|commandmove|commandradio|commandsuppressivefire|commandtarget|commandwatch|configclasses|confirmsensortarget|connectterminaltouav|controlsgroupctrl|copywaypoints|count|countenemy|countfriendly|countside|counttype|countunknown|create3denentity|creatediaryrecord|creatediarysubject|createdisplay|createhashmapfromarray|createmenu|createmissiondisplay|creatempcampaigndisplay|createsimpletask|createsite|createtask|createunit|createvehicle|createvehiclecrew|createvehiclelocal|ctdata|ctfindheaderrows|ctfindrowheader|ctheadercontrols|ctremoveheaders|ctremoverows|ctrlactivate|ctrladdeventhandler|ctrlanimatemodel|ctrlanimationphasemodel|ctrlat|ctrlchecked|ctrlcommit|ctrlcreate|ctrlenable|ctrlmapanimadd|ctrlmapcursor|ctrlmapscreentoworld|ctrlmapsetposition|ctrlmapworldtoscreen|ctrlremovealleventhandlers|ctrlremoveeventhandler|ctrlsetactivecolor|ctrlsetangle|ctrlsetautoscrolldelay|ctrlsetautoscrollrewind|ctrlsetautoscrollspeed|ctrlsetbackgroundcolor|ctrlsetchecked|ctrlsetdisabledcolor|ctrlseteventhandler|ctrlsetfade|ctrlsetfont|ctrlsetfonth1|ctrlsetfonth1b|ctrlsetfonth2|ctrlsetfonth2b|ctrlsetfonth3|ctrlsetfonth3b|ctrlsetfonth4|ctrlsetfonth4b|ctrlsetfonth5|ctrlsetfonth5b|ctrlsetfonth6|ctrlsetfonth6b|ctrlsetfontheight|ctrlsetfontheighth1|ctrlsetfontheighth2|ctrlsetfontheighth3|ctrlsetfontheighth4|ctrlsetfontheighth5|ctrlsetfontheighth6|ctrlsetfontheightsecondary|ctrlsetfontp|ctrlsetfontpb|ctrlsetfontsecondary|ctrlsetforegroundcolor|ctrlsetmodel|ctrlsetmodeldirandup|ctrlsetmodelscale|ctrlsetpixelprecision|ctrlsetposition|ctrlsetpositionh|ctrlsetpositionw|ctrlsetpositionx|ctrlsetpositiony|ctrlsetscale|ctrlsetscrollvalues|ctrlsetshadow|ctrlsetstructuredtext|ctrlsettext|ctrlsettextcolor|ctrlsettextcolorsecondary|ctrlsettextsecondary|ctrlsettextselection|ctrlsettooltip|ctrlsettooltipcolorbox|ctrlsettooltipcolorshade|ctrlsettooltipcolortext|ctrlsettooltipmaxwidth|ctrlseturloverlaymode|ctrlshow|ctrowcontrols|ctsetcursel|ctsetdata|ctsetheadertemplate|ctsetrowtemplate|ctsetvalue|ctvalue|curatorcoef|currentmagazinedetailturret|currentmagazineturret|currentvisionmode|currentweaponturret|currentzeroing|customchat|customradio|cutfadeout|cutobj|cutrsc|cuttext|debugfsm|deleteat|deleteeditorobject|deletegroupwhenempty|deleterange|deleteresources|deletevehiclecrew|diag_enable|diarysubjectexists|directionstabilizationenabled|directsay|disableai|disablebrakes|disablecollisionwith|disableconversation|disablenvgequipment|disabletiequipment|disableuavconnectability|displayaddeventhandler|displayctrl|displayremovealleventhandlers|displayremoveeventhandler|displayseteventhandler|distance|distance2d|distancesqr|doartilleryfire|dofire|dofollow|dofsm|domove|doorphase|dosuppressivefire|dotarget|dowatch|drawarrow|drawellipse|drawicon|drawline|drawlink|drawlocation|drawpolygon|drawrectangle|drawtriangle|editobject|editorseteventhandler|elevateperiscope|emptypositions|enableai|enableaifeature|enableaimprecision|enableattack|enableaudiofeature|enableautostartuprtd|enableautotrimrtd|enablechannel|enablecollisionwith|enablecopilot|enabledirectionstabilization|enabledynamicsimulation|enablefatigue|enablegunlights|enableinfopanelcomponent|enableirlasers|enablemimics|enablepersonturret|enablereload|enableropeattach|enablesimulation|enablesimulationglobal|enablestamina|enableuavconnectability|enableuavwaypoints|enablevehiclecargo|enablevehiclesensor|enableweapondisassembly|engineon|evalobjectargument|exec|execeditorscript|fademusic|faderadio|fadesound|fadespeech|find|findany|findcover|findeditorobject|findemptyposition|findemptypositionready|findif|findnearestenemy|fire|fireattarget|flyinheight|flyinheightasl|forceadduniform|forceflagtexture|forcefollowroad|forcespeed|forcewalk|forceweaponfire|foreachreversed|forgettarget|get3denattribute|get3denattributes|get3denmissionattribute|get3denmissionattributes|getartilleryeta|getcargoindex|getcompatiblepylonmagazines|getdir|getdirvisual|geteditorobjectscope|getentityinfo|getenv3dsoundcontroller|getenvsoundcontroller|geteventhandlerinfo|getfriend|getfsmvariable|getgroupicon|gethidefrom|gethit|gethitindex|gethitpointdamage|getobjectargument|getobjectchildren|getobjectproxy|getopticsmode|getordefaultcall|getpos|getreldir|getrelpos|getrespawnvehicleinfo|getselectionbones|getshotinfo|getslotitemname|getsoundcontroller|getsoundcontrollerresult|getspeed|gettextwidth|getturretlimits|getturretopticsmode|getunitmovesinfo|getunittrait|getuserinfo|getvariable|glanceat|globalchat|globalradio|groupchat|groupradio|groupselectunit|hasweapon|hcgroupparams|hcremovegroup|hcselectgroup|hcsetgroup|hideobject|hideobjectglobal|hideselection|hintc|htmlload|ignoretarget|in|inarea|inareaarray|inareaarrayindexes|inflame|infopanelcomponentenabled|infopanelcomponents|inpolygon|inrangeofartillery|inserteditorobject|intersect|isequalref|isequalto|isequaltype|isequaltypeall|isequaltypeany|isequaltypearray|isequaltypeparams|isflashlighton|isflatempty|isirlaseron|iskindof|islaseron|isnil|isnotequalref|issensortargetconfirmed|isuavconnectable|isuniformallowed|isvehiclesensorenabled|join|joinas|joinassilent|joinsilent|joinstring|kbadddatabase|kbadddatabasetargets|kbaddtopic|kbhastopic|kbreact|kbremovetopic|kbtell|kbwassaid|knowsabout|land|landat|lasertarget|lbadd|lbcolor|lbcolorright|lbdata|lbdelete|lbisselected|lbpicture|lbpictureright|lbsetcolor|lbsetcolorright|lbsetcursel|lbsetdata|lbsetpicture|lbsetpicturecolor|lbsetpicturecolordisabled|lbsetpicturecolorselected|lbsetpictureright|lbsetpicturerightcolor|lbsetpicturerightcolordisabled|lbsetpicturerightcolorselected|lbsetselectcolor|lbsetselectcolorright|lbsetselected|lbsettext|lbsettextright|lbsettooltip|lbsetvalue|lbsortby|lbtext|lbtextright|lbtooltip|lbvalue|leavevehicle|lightattachobject|limitspeed|linkitem|listobjects|lnbaddcolumn|lnbaddrow|lnbcolor|lnbcolorright|lnbdata|lnbdeletecolumn|lnbdeleterow|lnbpicture|lnbpictureright|lnbsetcolor|lnbsetcolorright|lnbsetcolumnspos|lnbsetcurselrow|lnbsetdata|lnbsetpicture|lnbsetpicturecolor|lnbsetpicturecolorright|lnbsetpicturecolorselected|lnbsetpicturecolorselectedright|lnbsetpictureright|lnbsettext|lnbsettextright|lnbsettooltip|lnbsetvalue|lnbsort|lnbsortby|lnbsortbyvalue|lnbtext|lnbtextright|lnbvalue|loadidentity|loadmagazine|loadoverlay|loadstatus|lock|lockcamerato|lockcargo|lockdriver|lockedcamerato|lockedcargo|lockedturret|lockinventory|lockturret|lockwp|lookat|lookatpos|magazinesturret|magazineturretammo|mapcenteroncamera|matrixmultiply|max|menuaction|menuadd|menuchecked|menucollapse|menudata|menudelete|menuenable|menuenabled|menuexpand|menupicture|menusetaction|menusetcheck|menusetdata|menusetpicture|menusetshortcut|menusettext|menuseturl|menusetvalue|menushortcut|menushortcuttext|menusize|menusort|menutext|menuurl|menuvalue|min|minedetectedby|mod|modeltoworld|modeltoworldvisual|modeltoworldvisualworld|modeltoworldworld|move|moveinany|moveincargo|moveincommander|moveindriver|moveingunner|moveinturret|moveobjecttoend|moveout|moveto|namedproperties|nearentities|nearestobject|nearobjects|nearobjectsready|nearroads|nearsupplies|neartargets|newoverlay|nmenuitems|objstatus|ondoubleclick|onmapsingleclick|onshownewobject|ordergetin|param|params|periscopeelevation|playaction|playactionnow|playgesture|playmove|playmovenow|posscreentoworld|posworldtoscreen|ppeffectadjust|ppeffectcommit|ppeffectenable|ppeffectforceinnvg|preloadobject|progresssetposition|publicvariableclient|pushback|pushbackunique|radiochanneladd|radiochannelremove|radiochannelsetcallsign|radiochannelsetlabel|random|regexfind|regexmatch|regexreplace|registertask|reload|remotecontrol|remoteexec|remoteexeccall|removeaction|removealleventhandlers|removeallmpeventhandlers|removebinocularitem|removecuratoraddons|removecuratorcameraarea|removecuratoreditableobjects|removecuratoreditingarea|removediaryrecord|removediarysubject|removedrawicon|removedrawlinks|removeeventhandler|removegroupicon|removehandgunitem|removeitem|removeitemfrombackpack|removeitemfromuniform|removeitemfromvest|removeitems|removemagazine|removemagazineglobal|removemagazines|removemagazinesturret|removemagazineturret|removemenuitem|removempeventhandler|removeownedmine|removeprimaryweaponitem|removesecondaryweaponitem|removesimpletask|removeteammember|removeweapon|removeweaponattachmentcargo|removeweaponcargo|removeweaponglobal|removeweaponturret|reportremotetarget|resize|respawnvehicle|reveal|revealmine|ropeattachto|ropedetach|saveidentity|savestatus|say|say2d|say3d|select|selectdiarysubject|selecteditorobject|selectionnames|selectionposition|selectionvectordirandup|selectleader|selectrandomweighted|selectthrowable|selectweapon|selectweaponturret|sendsimplecommand|sendtask|sendtaskresult|servercommand|set|set3denattribute|set3denlayer|set3denlogictype|set3denmissionattribute|set3denobjecttype|setactualcollectivertd|setairplanethrottle|setairportside|setammo|setammocargo|setammoonpylon|setangularvelocity|setangularvelocitymodelspace|setanimspeedcoef|setattributes|setautonomous|setbehaviour|setbehaviourstrong|setbleedingremaining|setbrakesrtd|setcamerainterest|setcamuseti|setcaptive|setcenterofmass|setcollisionlight|setcombatmode|setconvoyseparation|setcruisecontrol|setcuratorcameraareaceiling|setcuratorcoef|setcuratoreditingareatype|setcuratorselectionpreset|setcuratorwaypointcost|setcurrenttask|setcurrentwaypoint|setcustomaimcoef|setcustomweightrtd|setdamage|setdammage|setdebriefingtext|setdestination|setdiaryrecordtext|setdir|setdirection|setdrawicon|setdriveonpath|setdropinterval|setdynamicsimulationdistance|setdynamicsimulationdistancecoef|seteditormode|seteditorobjectscope|seteffectcondition|seteffectivecommander|setenginerpmrtd|setface|setfaceanimation|setfatigue|setfeaturetype|setflaganimationphase|setflagowner|setflagside|setflagtexture|setfog|setforcegeneratorrtd|setformation|setformationtask|setformdir|setfriend|setfromeditor|setfsmvariable|setfuel|setfuelcargo|setfuelconsumptioncoef|setgroupicon|setgroupiconparams|setgroupid|setgroupidglobal|setgroupowner|setgusts|sethidebehind|sethit|sethitindex|sethitpointdamage|setidentity|setimportance|setleader|setlightambient|setlightattenuation|setlightbrightness|setlightcolor|setlightconepars|setlightdaylight|setlightflaremaxdistance|setlightflaresize|setlightintensity|setlightir|setlightnings|setlightuseflare|setlightvolumeshape|setmagazineturretammo|setmarkeralpha|setmarkeralphalocal|setmarkerbrush|setmarkerbrushlocal|setmarkercolor|setmarkercolorlocal|setmarkerdir|setmarkerdirlocal|setmarkerdrawpriority|setmarkerpos|setmarkerposlocal|setmarkershape|setmarkershapelocal|setmarkersize|setmarkersizelocal|setmarkertext|setmarkertextlocal|setmarkertype|setmarkertypelocal|setmass|setmaxload|setmimic|setmissiletarget|setmissiletargetpos|setmusiceffect|setname|setnamesound|setobjectarguments|setobjectmaterial|setobjectmaterialglobal|setobjectproxy|setobjecttexture|setobjecttextureglobal|setopticsmode|setovercast|setowner|setoxygenremaining|setparticlecircle|setparticleclass|setparticlefire|setparticleparams|setparticlerandom|setpilotcameradirection|setpilotcameraopticsmode|setpilotcamerarotation|setpilotcameratarget|setpilotlight|setpipeffect|setpitch|setplatenumber|setplayervonvolume|setpos|setposasl|setposasl2|setposaslw|setposatl|setposition|setposworld|setpylonloadout|setpylonspriority|setradiomsg|setrain|setrainbow|setrandomlip|setrank|setrectangular|setrepaircargo|setrotorbrakertd|setshotparents|setside|setsimpletaskalwaysvisible|setsimpletaskcustomdata|setsimpletaskdescription|setsimpletaskdestination|setsimpletasktarget|setsimpletasktype|setsize|setskill|setslingload|setsoundeffect|setspeaker|setspeech|setspeedmode|setstamina|setsuppression|settargetage|settaskmarkeroffset|settaskresult|settaskstate|settext|settitleeffect|settowparent|settriggeractivation|settriggerarea|settriggerinterval|settriggerstatements|settriggertext|settriggertimeout|settriggertype|setturretlimits|setturretopticsmode|settype|setunconscious|setunitability|setunitfreefallheight|setunitloadout|setunitpos|setunitposweak|setunitrank|setunitrecoilcoefficient|setunittrait|setunloadincombat|setuseractiontext|setusermfdtext|setusermfdvalue|setvariable|setvectordir|setvectordirandup|setvectorup|setvehicleammo|setvehicleammodef|setvehiclearmor|setvehiclecargo|setvehicleid|setvehiclelock|setvehicleposition|setvehicleradar|setvehiclereceiveremotetargets|setvehiclereportownposition|setvehiclereportremotetargets|setvehicletipars|setvehiclevarname|setvelocity|setvelocitymodelspace|setvelocitytransformation|setvisibleiftreecollapsed|setwantedrpmrtd|setwaterfillpercentage|setwaterleakiness|setwaves|setwaypointbehaviour|setwaypointcombatmode|setwaypointcompletionradius|setwaypointdescription|setwaypointforcebehaviour|setwaypointformation|setwaypointhouseposition|setwaypointloiteraltitude|setwaypointloiterradius|setwaypointloitertype|setwaypointname|setwaypointposition|setwaypointscript|setwaypointspeed|setwaypointstatements|setwaypointtimeout|setwaypointtype|setwaypointvisible|setweaponreloadingtime|setwinddir|setwindforce|setwindstr|setwingforcescalertd|setwppos|show3dicons|showlegend|showneweditorobject|showwaypoint|sidechat|sideradio|skill|skillfinal|slidersetposition|slidersetrange|slidersetspeed|sort|splitstring|stop|suppressfor|swimindepth|switchaction|switchcamera|switchgesture|switchlight|switchmove|synchronizeobjectsadd|synchronizeobjectsremove|synchronizetrigger|synchronizewaypoint|targetknowledge|targets|targetsaggregate|targetsquery|toarray|tofixed|triggerattachobject|triggerattachvehicle|triggerdynamicsimulation|trim|turretlocal|turretowner|turretunit|tvadd|tvcollapse|tvcount|tvdata|tvdelete|tvexpand|tvpicture|tvpictureright|tvsetcolor|tvsetcursel|tvsetdata|tvsetpicture|tvsetpicturecolor|tvsetpicturecolordisabled|tvsetpicturecolorselected|tvsetpictureright|tvsetpicturerightcolor|tvsetpicturerightcolordisabled|tvsetpicturerightcolorselected|tvsetselectcolor|tvsettext|tvsettooltip|tvsetvalue|tvsort|tvsortbyvalue|tvtext|tvtooltip|tvvalue|unassignitem|unitsbelowheight|unitturret|unlinkitem|unregistertask|updatedrawicon|updatemenuitem|useaisteeringcomponent|useaudiotimeformoves|vectoradd|vectorcos|vectorcrossproduct|vectordiff|vectordistance|vectordistancesqr|vectordotproduct|vectorfromto|vectormodeltoworld|vectormodeltoworldvisual|vectormultiply|vectorworldtomodel|vectorworldtomodelvisual|vehiclechat|vehicleradio|waypointattachobject|waypointattachvehicle|weaponaccessories|weaponaccessoriescargo|weapondirection|weaponreloadingtime|weaponsinfo|weaponstate|weaponsturret|worldtomodel|worldtomodelvisual)\\b',
      name: 'support.function.sqf'
    },
    {
      match:
        '\\b(?i:apertureparams|createhashmap|diag_dumpterrainsynth|diag_scope|environmentvolume|missionnamesource|speechvolume|acctime|activatedaddons|agents|airdensitycurvertd|all3denentities|allactivetitleeffects|alladdonsinfo|allairports|allcurators|allcutlayers|alldead|alldeadmen|alldisplays|allenv3dsoundsources|allgroups|allmapmarkers|allmines|allplayers|allsites|allunits|allunitsuav|allusers|ambienttemperature|armorypoints|benchmark|briefingname|buldozer_isenabledroaddiag|buldozer_reloadopermap|cadetmode|cameraon|cameraview|campaignconfigfile|cansuspend|cheatsenabled|clearforcesrtd|clearitempool|clearmagazinepool|clearradio|clearweaponpool|clientowner|commandingmenu|configfile|copyfromclipboard|curatorcamera|curatormouseover|curatorselected|current3denoperation|currentchannel|currentnamespace|cursorobject|cursortarget|customwaypointposition|date|daytime|diag_activemissionfsms|diag_activescripts|diag_activesqfscripts|diag_activesqsscripts|diag_allmissioneventhandlers|diag_deltatime|diag_dumpcalltracetolog|diag_fps|diag_fpsmin|diag_frameno|diag_resetanims|diag_resetfsm|diag_resetshapes|diag_stacktrace|diag_ticktime|dialog|diaryrecordnull|didjip|difficulty|difficultyenabledrtd|disabledebriefingstats|disableserialization|distributionregion|dynamicsimulationsystemenabled|enableenddialog|endloadingscreen|environmentenabled|estimatedendservertime|exit|finishmissioninit|focuson|fog|fogforecast|fogparams|forcedmap|forceend|forceweatherchange|freelook|get3dencamera|get3deniconsvisible|get3denlinesvisible|get3denmouseover|getartillerycomputersettings|getaudiooptionvolumes|getcalculateplayervisibilitybyfriendly|getclientstate|getclientstatenumber|getcursorobjectparams|getdlcassetsusage|getelevationoffset|getlighting|getloadedmodsinfo|getmissiondlcs|getmissionlayers|getmissionoptions|getmouseposition|getmusicplayedtime|getobjectviewdistance|getpipviewdistance|getremotesensorsdisabled|getresolution|getshadowdistance|getsteamfriendsservers|getsubtitleoptions|getterraingrid|getterraininfo|gettiparameters|gettotaldlcusagetime|getvideooptions|groupiconselectable|groupiconsvisible|gusts|halt|hasinterface|hcshownbar|hudmovementlevels|humidity|initambientlife|is3den|is3denmultiplayer|is3denpreview|isactionmenuvisible|isautotest|isdedicated|isfilepatchingenabled|isgamefocused|isgamepaused|isinstructorfigureenabled|ismissionprofilenamespaceloaded|ismultiplayer|ismultiplayersolo|ispipenabled|isremoteexecuted|isremoteexecutedjip|issaving|isserver|issteammission|issteamoverlayenabled|isstreamfriendlyuienabled|isstressdamageenabled|istuthintsenabled|isuicontext|isusingaisteeringcomponent|language|librarycredits|librarydisclaimers|lightnings|loadgame|localnamespace|logentities|mapanimclear|mapanimcommit|mapanimdone|markasfinishedonsteam|missionconfigfile|missiondifficulty|missionend|missionname|missionnamespace|missionprofilenamespace|missionstart|missionversion|moonintensity|musicvolume|netobjnull|nextweatherchange|opencuratorinterface|overcast|overcastforecast|parsingnamespace|particlesquality|pixelgrid|pixelgridbase|pixelgridnouiscale|pixelh|pixelw|playableunits|player|playerrespawntime|playerside|playertargetlock|privateall|productversion|profilename|profilenamespace|profilenamesteam|radioenabled|radiovolume|rain|rainbow|rainparams|remoteexecutedowner|resetcamshake|reversedmousey|runinitscript|safezoneh|safezonew|safezonewabs|safezonex|safezonexabs|safezoney|save3denpreferences|savegame|savejoysticks|savemissionprofilenamespace|saveprofilenamespace|savingenabled|selectnoplayer|sentencesenabled|servername|servernamespace|servertime|shownartillerycomputer|shownchat|showncompass|showncuratorcompass|showngps|shownhud|shownmap|shownpad|shownradio|shownscoretable|shownsubtitles|shownuavfeed|shownwarrant|shownwatch|sideenemy|sidefriendly|simulweathersync|slingloadassistantshown|soundvolume|sunormoon|switchableunits|systemofunits|systemtime|systemtimeutc|teams|teamswitch|teamswitchenabled|time|timemultiplier|uinamespace|userinputdisabled|vehicles|viewdistance|visiblecompass|visiblegps|visiblemap|visiblescoretable|visiblewatch|waves|wind|winddir|windrtd|windstr|worldname|worldsize)\\b',
      name: 'support.function.sqf'
    },
    {
      match:
        '\\b0x[a-fA-F\\d]+|\\b\\d+(\\.\\d+)?([eE]-?\\d+)?|\\.\\d+([eE]-?\\d+)?',
      name: 'constant.numeric.sqf'
    },
    {
      match: '<\\=|>\\=|\\=\\=|<|>|\\!\\=',
      name: 'keyword.operator.comparison.sqf'
    },
    {
      begin: '//',
      beginCaptures: {0: {name: 'punctuation.definition.comment.sqf'}},
      end: '$\\n?',
      name: 'comment.line.sqf'
    },
    {
      begin: '/\\*',
      captures: {0: {name: 'punctuation.definition.comment.sqf'}},
      end: '\\*/',
      name: 'comment.block.sqf'
    },
    {match: '\\+|\\-|\\*|\\/|%|\\^', name: 'keyword.operator.arithmetic.sqf'},
    {match: '\\=', name: 'keyword.operator.assignment.sqf'},
    {
      begin: '"',
      beginCaptures: {0: {name: 'punctuation.definition.string.begin.sqf'}},
      end: '"',
      endCaptures: {0: {name: 'punctuation.definition.string.end.sqf'}},
      name: 'string.quoted.double.sqf'
    },
    {
      begin: "'",
      beginCaptures: {0: {name: 'punctuation.definition.string.begin.sqf'}},
      end: "'",
      endCaptures: {0: {name: 'punctuation.definition.string.end.sqf'}},
      name: 'string.quoted.sqf'
    },
    {
      begin: '@"',
      beginCaptures: {0: {name: 'punctuation.definition.string.begin.sqf'}},
      end: '"@',
      endCaptures: {0: {name: 'punctuation.definition.string.end.sqf'}},
      name: 'string.quoted.region.sqf'
    },
    {match: '\\b_[a-zA-Z_][a-zA-Z0-9_]*', name: 'variable.other.sqf'},
    {match: '[a-zA-Z]\\w+_fnc_\\w+', name: 'variable.function.sqf'},
    {match: '\\b__[a-zA-Z_][a-zA-Z0-9_]*', name: 'constant.other.sqf'}
  ],
  scopeName: 'source.sqf'
}

export default grammar
